﻿using FarPoint.Win.Spread;
using System;
using System.Collections;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace ChildViewCreate
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
            fpSpread1.ChildViewCreated += FpSpread1_ChildViewCreated;
        }

        private void FpSpread1_ChildViewCreated(object sender, FarPoint.Win.Spread.ChildViewCreatedEventArgs e)
        {
            try
            {
                e.SheetView.ColumnHeader.DefaultStyle.Renderer = new FarPoint.Win.Spread.CellType.ColumnHeaderRenderer();
                e.SheetView.RowHeader.DefaultStyle.Renderer = new FarPoint.Win.Spread.CellType.RowHeaderRenderer();
                e.SheetView.SheetCorner.DefaultStyle.Renderer = new FarPoint.Win.Spread.CellType.CornerRenderer();

                fpSpread1.InterfaceRenderer = null;
                fpSpread1.HorizontalScrollBar.Renderer = null;
                fpSpread1.VerticalScrollBar.Renderer = null;

                //e.SheetView.AlternatingRows[1].BackColor = Color.LightPink;
                //e.SheetView.AlternatingRows[0].BackColor = Color.WhiteSmoke;
                e.SheetView.Rows.Default.Resizable = false;
                if (e.SheetView.ColumnCount >= 4 && e.SheetView.RowCount >= 0 && e.SheetView.ColumnHeader.Columns[0].Label == "N2")
                {
                    e.SheetView.Columns[0].Visible = false;
                    e.SheetView.Columns[1].Visible = false;
                    e.SheetView.SetColumnWidth(2, 185);
                    e.SheetView.SetColumnWidth(3, 185);
                    e.SheetView.Columns[4].Visible = false;
                    //L_svCollection.Add(e.SheetView)
                }
                else if (e.SheetView.ColumnCount >= 7 && e.SheetView.RowCount >= 0 && e.SheetView.ColumnHeader.Columns[0].Label == "N3")
                {
                    e.SheetView.Columns[0, 1].Visible = false;
                    e.SheetView.SetColumnWidth(2, 120);
                    e.SheetView.SetColumnWidth(3, 80);
                    e.SheetView.SetColumnWidth(4, 120);
                    e.SheetView.SetColumnWidth(5, 80);
                    e.SheetView.Columns[6, 7].Visible = false;
                }
                else if (e.SheetView.ColumnCount >= 5 && e.SheetView.RowCount >= 0 && e.SheetView.ColumnHeader.Columns[0].Label == "N4")
                {
                    e.SheetView.Columns[0, 1].Visible = false;
                    e.SheetView.SetColumnWidth(2, 200);
                    e.SheetView.Columns[3, 5].Visible = false;
                }
                else if (e.SheetView.ColumnCount >= 9 && e.SheetView.RowCount >= 0 && e.SheetView.ColumnHeader.Columns[0].Label == "N5")
                {
                    e.SheetView.Columns[0, 1].Visible = false;
                    e.SheetView.SetColumnWidth(2, 100);
                    e.SheetView.SetColumnWidth(3, 100);
                    e.SheetView.SetColumnWidth(4, 20);
                    e.SheetView.Columns[5].Visible = false;
                    e.SheetView.SetColumnWidth(6, 110);
                    e.SheetView.Columns[7, 9].Visible = false;
                    //L_svCollection.Add(e.SheetView)
                }
                else if (e.SheetView.ColumnCount >= 9 && e.SheetView.RowCount >= 0 && e.SheetView.ColumnHeader.Columns[0].Label == "N6")
                {
                    e.SheetView.Columns[0, 1].Visible = false;
                    e.SheetView.SetColumnWidth(2, 250);
                    e.SheetView.Columns[3, 8].Visible = false;
                    e.SheetView.SetColumnWidth(9, 50);
                    e.SheetView.Columns[9].HorizontalAlignment = CellHorizontalAlignment.Center;
                }
            }
            catch (Exception eA) 
            { 
                MessageBox.Show(eA.Message); 
            }
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            ArrayList list = new ArrayList();
            Student s = new Student();
            s.Name = "John Smith";
            s.Id = "100001";
            Score sc = new Score();
            sc.ClassName = "math";
            sc.Grade = "A";
            s.Score.Add(sc);
            sc = new Score();
            sc.ClassName = "English";
            sc.Grade = "A";
            s.Score.Add(sc);
            sc = new Score();
            sc.ClassName = "Science";
            sc.Grade = "A";
            s.Score.Add(sc);
            sc = new Score();
            sc.ClassName = "Biology";
            sc.Grade = "A";
            s.Score.Add(sc);
            list.Add(s);
            s = new Student();
            s.Name = "David Black";
            s.Id = "100002";
            sc = new Score();
            sc.ClassName = "math";
            sc.Grade = "B";
            s.Score.Add(sc);
            sc = new Score();
            sc.ClassName = "English";
            sc.Grade = "A";
            s.Score.Add(sc);
            list.Add(s);
            fpSpread1_Sheet1.DataSource = list;
        }
    }

    public class Score
    {
        private string classname;
        private string grade;
        public string ClassName
        {
            get { return classname; }
            set { classname = value; }
        }
        public string Grade
        {
            get { return grade; }
            set { grade = value; }
        }
    }

    public class Student
    {
        private string name;
        private string id;
        private ArrayList score = new ArrayList();
        public string Name
        {
            get { return name; }
            set { name = value; }
        }
        public string Id
        {
            get { return id; }
            set { id = value; }
        }
        public ArrayList Score
        {
            get { return score; }
        }
    }

}
